package v1

import (
	"github.com/gin-gonic/gin"
)

import (
	"resource-server/common"
	"resource-server/service"
)

func Ping(c *gin.Context) {
	common.HttpSuccess(c, "Pong")
}

func Login(c *gin.Context) {
	request := &struct {
		Username string `json:"username" binding:"required"`
		Password string `json:"password" binding:"required"`
	}{}
	if err := c.ShouldBindJSON(request); err != nil {
		common.HttpErr(c, err)
		return
	}
	res, err := service.Login(request.Username, request.Password)
	if err != nil {
		common.HttpErr(c, err)
		return
	}
	common.HttpSuccess(c, res)
}
