package common

type Lang string

const (
	Lang_en Lang = "en"
	Lang_zh Lang = "zh"
)

func (p Lang) toString() string {
	switch p {
	case Lang_en:
		return "en"
	case Lang_zh:
		return "zh"
	}
	return ""
}

func ValidLanguages(langs []Lang) bool {
	for _, lang := range langs {
		if lang.toString() == "" {
			return false
		}
	}
	return true
}

func AllLanguages() []Lang {
	return []Lang{Lang_en, Lang_zh}
}
