package router

import (
	"github.com/gin-gonic/gin"
	apiv1 "resource-server/api/v1"
)

func InitRouter() *gin.Engine {

	r := gin.New()

	InitMiddleware(r)

	r.StaticFile("/dr/", "./dist/index.html")
	r.Static("/dr/front/", "./dist/")

	// 注册路由
	v1 := r.Group("/dr/api/v1/")
	pubV1 := v1.Group("/pub")
	{
		pubV1.GET("/ping", apiv1.Ping)
		pubV1.POST("login", apiv1.Login)
	}
	authV1 := v1.Group("/auth")
	{
		configV1 := authV1.Group("/configs")
		{
			configV1.GET("items", apiv1.GetConfigs)
			configV1.GET("options", apiv1.GetConfigOptions)
			configV1.POST("items", apiv1.UpdateConfigItems)
		}
	}
	return r
}
