package static

import (
	"embed"
	"errors"
	"io/fs"
)

//go:embed sqls
var sqlFiles embed.FS

func GetSqlFile(filename string) (fs.File, error) {
	localeEntries, err := sqlFiles.ReadDir("sqls")
	if err != nil {
		return nil, err
	}
	for _, le := range localeEntries {
		if le.IsDir() {
		} else {
			if le.Name() == filename {
				f, err := sqlFiles.Open("sqls/" + le.Name())
				if err != nil {
					return nil, err
				}
				return f, nil
			}
		}
	}
	return nil, errors.New("sql file not exist, " + filename)
}
